/* $Id: platform_c.c 222 2010-06-11 14:15:23Z gerd $ */

/* Helpers for mapred performance */

#include <string.h>
#include <caml/fail.h>
#include <caml/bigarray.h>

/* external find_lf :  Netsys_mem.memory -> int -> int -> int 
  = "mapred_find_lf"

   Looks for LF char from mem[pos] to mem[endpos-1] and returns the
   position. Not_found if not found.
 */

CAMLprim value mapred_find_lf (value memv, value posv, value endposv) {
    struct caml_bigarray *mem = Bigarray_val(memv);
    long pos = Long_val(posv);
    long endpos = Long_val(endposv);
    char *m = (char *) mem->data;
    char *found;

    found = (char *) memchr(m + pos, '\n', endpos-pos);
    if (found == NULL) caml_raise_not_found();

    return (Val_long (found - m));
}
